import 'dates_export.dart';

String formatToOffset(DateTimeFormat format) {
  switch (format) {
    case DateTimeFormat.utc_m12:
      return '-12:00';
    case DateTimeFormat.utc_m11:
      return '-11:00';
    case DateTimeFormat.utc_m10:
      return '-10:00';
    case DateTimeFormat.utc_m9_30:
      return '-09:30';
    case DateTimeFormat.utc_m9:
      return '-09:00';
    case DateTimeFormat.utc_m8:
      return '-08:00';
    case DateTimeFormat.utc_m7:
      return '-07:00';
    case DateTimeFormat.utc_m6:
      return '-06:00';
    case DateTimeFormat.utc_m5:
      return '-05:00';
    case DateTimeFormat.utc_m4:
      return '-04:00';
    case DateTimeFormat.utc_m3_30:
      return '-03:30';
    case DateTimeFormat.utc_m3:
      return '-03:00';
    case DateTimeFormat.utc_m2:
      return '-02:00';
    case DateTimeFormat.utc_m1:
      return '-01:00';
    case DateTimeFormat.utc_m0:
      return '-00:00';
    case DateTimeFormat.utc_p0:
      return '+00:00';
    case DateTimeFormat.utc_p1:
      return '+01:00';
    case DateTimeFormat.utc_p2:
      return '+02:00';
    case DateTimeFormat.utc_p3:
      return '+03:00';
    case DateTimeFormat.utc_p3_30:
      return '+03:30';
    case DateTimeFormat.utc_p4:
      return '+04:00';
    case DateTimeFormat.utc_p4_30:
      return '+04:30';
    case DateTimeFormat.utc_p5:
      return '+05:00';
    case DateTimeFormat.utc_p5_30:
      return '+05:30';
    case DateTimeFormat.utc_p5_45:
      return '+05:45';
    case DateTimeFormat.utc_p6:
      return '+06:00';
    case DateTimeFormat.utc_p6_30:
      return '+06:30';
    case DateTimeFormat.utc_p7:
      return '+07:00';
    case DateTimeFormat.utc_p8:
      return '+08:00';
    case DateTimeFormat.utc_p8_45:
      return '+08:45';
    case DateTimeFormat.utc_p9:
      return '+09:00';
    case DateTimeFormat.utc_p9_30:
      return '+09:30';
    case DateTimeFormat.utc_p10:
      return '+10:00';
    case DateTimeFormat.utc_p10_30:
      return '+10:30';
    case DateTimeFormat.utc_p11:
      return '+11:00';
    case DateTimeFormat.utc_p12:
      return '+12:00';
    case DateTimeFormat.utc_p12_45:
      return '+12:45';
    case DateTimeFormat.utc_p13:
      return '+13:00';
    case DateTimeFormat.utc_p14:
      return '+14:00';
    default:
      return 'incorrect format';
  }
}

DateTimeFormat offsetToFormat(String offset) {
  switch (offset) {
    case '-12:00':
      return DateTimeFormat.utc_m12;
    case '-11:00':
      return DateTimeFormat.utc_m11;
    case '-10:00':
      return DateTimeFormat.utc_m10;
    case '-09:30':
      return DateTimeFormat.utc_m9_30;
    case '-09:00':
      return DateTimeFormat.utc_m9;
    case '-08:00':
      return DateTimeFormat.utc_m8;
    case '-07:00':
      return DateTimeFormat.utc_m7;
    case '-06:00':
      return DateTimeFormat.utc_m6;
    case '-05:00':
      return DateTimeFormat.utc_m5;
    case '-04:00':
      return DateTimeFormat.utc_m4;
    case '-03:30':
      return DateTimeFormat.utc_m3_30;
    case '-03:00':
      return DateTimeFormat.utc_m3;
    case '-02:00':
      return DateTimeFormat.utc_m2;
    case '-01:00':
      return DateTimeFormat.utc_m1;
    case '-00:00':
      return DateTimeFormat.utc_m0;
    case '+00:00':
      return DateTimeFormat.utc_p0;
    case '+01:00':
      return DateTimeFormat.utc_p1;
    case '+02:00':
      return DateTimeFormat.utc_p2;
    case '+03:00':
      return DateTimeFormat.utc_p3;
    case '+03:30':
      return DateTimeFormat.utc_p3_30;
    case '+04:00':
      return DateTimeFormat.utc_p4;
    case '+04:30':
      return DateTimeFormat.utc_p4_30;
    case '+05:00':
      return DateTimeFormat.utc_p5;
    case '+05:30':
      return DateTimeFormat.utc_p5_30;
    case '+05:45':
      return DateTimeFormat.utc_p5_45;
    case '+06:00':
      return DateTimeFormat.utc_p6;
    case '+06:30':
      return DateTimeFormat.utc_p6_30;
    case '+07:00':
      return DateTimeFormat.utc_p7;
    case '+08:00':
      return DateTimeFormat.utc_p8;
    case '+08:45':
      return DateTimeFormat.utc_p8_45;
    case '+09:00':
      return DateTimeFormat.utc_p9;
    case '+09:30':
      return DateTimeFormat.utc_p9_30;
    case '+10:00':
      return DateTimeFormat.utc_p10;
    case '+10:30':
      return DateTimeFormat.utc_p10_30;
    case '+11:00':
      return DateTimeFormat.utc_p11;
    case '+12:00':
      return DateTimeFormat.utc_p12;
    case '+12:45':
      return DateTimeFormat.utc_p12_45;
    case '+13:00':
      return DateTimeFormat.utc_p13;
    case '+14:00':
      return DateTimeFormat.utc_p14;
    default:
      return DateTimeFormat.incorrect_format;
  }
}
